
%define debug_package %{nil}
Name:    tezos-node
Version: 16.0rc2
Release: 1
Epoch: 1
Summary: Entry point for initializing, configuring and running a Tezos node
License: MIT
BuildArch: x86_64 aarch64
Source0: tezos-node-16.0rc2.tar.gz
Source1: https://gitlab.com/tezos/tezos/tree/v16.0-rc2/
BuildRequires: make wget systemd systemd-rpm-macros
Requires: , tezos-sapling-params, curl
%description
Entry point for initializing, configuring and running a Tezos node
Maintainer: Serokell <hi@serokell.io>
%prep
%setup -q
%build
%install
make octez-node
mkdir -p %{buildroot}/%{_bindir}
install -m 0755 octez-node %{buildroot}/%{_bindir}
ln -s %{_bindir}/octez-node %{buildroot}/%{_bindir}/tezos-node
install -m 0755 octez-node-mainnet %{buildroot}/%{_bindir}/

install -m 0755 octez-node-ghostnet %{buildroot}/%{_bindir}/

install -m 0755 octez-node-limanet %{buildroot}/%{_bindir}/

install -m 0755 octez-node-mumbainet %{buildroot}/%{_bindir}/

ln -s %{_bindir}/octez-node-mainnet %{buildroot}/%{_bindir}/tezos-node-mainnet
ln -s %{_bindir}/octez-node-ghostnet %{buildroot}/%{_bindir}/tezos-node-ghostnet
ln -s %{_bindir}/octez-node-limanet %{buildroot}/%{_bindir}/tezos-node-limanet
ln -s %{_bindir}/octez-node-mumbainet %{buildroot}/%{_bindir}/tezos-node-mumbainet

mkdir -p %{buildroot}/%{_unitdir}
install -m 644 tezos-node-mainnet.service %{buildroot}/%{_unitdir}
install -m 644 tezos-node-ghostnet.service %{buildroot}/%{_unitdir}
install -m 644 tezos-node-limanet.service %{buildroot}/%{_unitdir}
install -m 644 tezos-node-mumbainet.service %{buildroot}/%{_unitdir}
install -m 644 tezos-node-custom.service %{buildroot}/%{_unitdir}
install -m 644 tezos-node-custom@.service %{buildroot}/%{_unitdir}

mkdir -p %{buildroot}/%{_sysconfdir}/default
install -m 644 tezos-node-mainnet.default %{buildroot}/%{_sysconfdir}/default/tezos-node-mainnet
install -m 644 tezos-node-ghostnet.default %{buildroot}/%{_sysconfdir}/default/tezos-node-ghostnet
install -m 644 tezos-node-limanet.default %{buildroot}/%{_sysconfdir}/default/tezos-node-limanet
install -m 644 tezos-node-mumbainet.default %{buildroot}/%{_sysconfdir}/default/tezos-node-mumbainet
install -m 644 tezos-node-custom.default %{buildroot}/%{_sysconfdir}/default/tezos-node-custom
install -m 644 tezos-node-custom@.default %{buildroot}/%{_sysconfdir}/default/tezos-node-custom@

install -m 0755 tezos-node-custom-poststop %{buildroot}/%{_bindir}
install -m 0755 tezos-node-start %{buildroot}/%{_bindir}
install -m 0755 tezos-node-prestart %{buildroot}/%{_bindir}


%files
%license LICENSE
%{_bindir}/octez-node-mainnet
%{_bindir}/tezos-node-mainnet
%{_bindir}/octez-node-ghostnet
%{_bindir}/tezos-node-ghostnet
%{_bindir}/octez-node-limanet
%{_bindir}/tezos-node-limanet
%{_bindir}/octez-node-mumbainet
%{_bindir}/tezos-node-mumbainet
%{_bindir}/octez-node
%{_bindir}/tezos-node

%{_bindir}/tezos-node-custom-poststop
%{_bindir}/tezos-node-start
%{_bindir}/tezos-node-prestart

%{_unitdir}/tezos-node-mainnet.service
%{_unitdir}/tezos-node-ghostnet.service
%{_unitdir}/tezos-node-limanet.service
%{_unitdir}/tezos-node-mumbainet.service
%{_unitdir}/tezos-node-custom.service
%{_unitdir}/tezos-node-custom@.service

%{_sysconfdir}/default/tezos-node-mainnet
%{_sysconfdir}/default/tezos-node-ghostnet
%{_sysconfdir}/default/tezos-node-limanet
%{_sysconfdir}/default/tezos-node-mumbainet
%{_sysconfdir}/default/tezos-node-custom
%{_sysconfdir}/default/tezos-node-custom@



%post
%systemd_post tezos-node-mainnet.service
%systemd_post tezos-node-ghostnet.service
%systemd_post tezos-node-limanet.service
%systemd_post tezos-node-mumbainet.service
%systemd_post tezos-node-custom.service
%systemd_post tezos-node-custom@.service


if [ -z $(getent passwd tezos) ]; then
    useradd -r -s /bin/false -m -d /var/lib/tezos tezos
    chmod 0755 /var/lib/tezos
fi

mkdir -p /var/lib/tezos/node-mainnet
[ ! -f /var/lib/tezos/node-mainnet/config.json ] && octez-node config init --data-dir /var/lib/tezos/node-mainnet --network mainnet
chown -R tezos:tezos /var/lib/tezos/node-mainnet

mkdir -p /var/lib/tezos/node-ghostnet
[ ! -f /var/lib/tezos/node-ghostnet/config.json ] && octez-node config init --data-dir /var/lib/tezos/node-ghostnet --network ghostnet
chown -R tezos:tezos /var/lib/tezos/node-ghostnet

mkdir -p /var/lib/tezos/node-limanet
[ ! -f /var/lib/tezos/node-limanet/config.json ] && octez-node config init --data-dir /var/lib/tezos/node-limanet --network limanet
chown -R tezos:tezos /var/lib/tezos/node-limanet

mkdir -p /var/lib/tezos/node-mumbainet
[ ! -f /var/lib/tezos/node-mumbainet/config.json ] && octez-node config init --data-dir /var/lib/tezos/node-mumbainet --network mumbainet
chown -R tezos:tezos /var/lib/tezos/node-mumbainet
mkdir -p /var/lib/tezos/node-custom


%preun
%systemd_preun tezos-node-mainnet.service
%systemd_preun tezos-node-ghostnet.service
%systemd_preun tezos-node-limanet.service
%systemd_preun tezos-node-mumbainet.service
%systemd_preun tezos-node-custom.service
%systemd_preun tezos-node-custom@.service


%postun
%systemd_postun_with_restart tezos-node-mainnet.service
%systemd_postun_with_restart tezos-node-ghostnet.service
%systemd_postun_with_restart tezos-node-limanet.service
%systemd_postun_with_restart tezos-node-mumbainet.service
%systemd_postun_with_restart tezos-node-custom.service
%systemd_postun_with_restart tezos-node-custom@.service



